;;; qvsa-pkg-lsd.el --- Qvasir supplement package for lsd-fuw  -*- coding: utf-8  -*-
;; Copyright (C) 2010  Kazuhiro Ito <kzhr@d1.dion.ne.jp>

;; Author: Kazuhiro Ito <kzhr@d1.dion.nejp>
;; Target: ebs, eb
;; Format: 1.1
;; Version: 1.0

;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License
;; as published by the Free Software Foundation; either version 2
;; of the License, or (at your option) any later version.

;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software Foundation,
;; Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;;; Code:

(require 'qvs-package)

(defconst qvsa-pkg-lsd-dictionary-options
  '((:adjusts . (qvs-adjust-check-references
		 qvs-adjust-show-gaijis
		 qvsa-pkg-lsd-adjust-goto))
    (:backward-methods  . (keyword))
    (:arranges . (qvsa-eb-arrange-indent
		  qvsa-eb-arrange-faces
		  qvsa-eb-arrange-ignore
		  qvsa-eb-arrange-prev-next
		  qvs-arrange-references
		  qvsa-eb-arrange-decode-entity
		  qvs-arrange-default-headings
		  qvsa-pkg-lsd-arrange-headings
		  qvsa-eb-arrange-fill-lines
		  ))))

(put 'qvsa-eb ':adjusts
     '(qvs-adjust-check-references
       qvs-adjust-show-gaijis
       qvs-adjust-goto-min))


(defun qvsa-pkg-lsd-adjust-goto (entry)
  (let ((string (qvs-entry-heading entry)))
    (when (and (string-match "^・\\(.+\\)$" string)
	       (re-search-forward
		(replace-regexp-in-string
		 "[ \t]+" "[ \t\n]+" (regexp-quote string) t t)
		nil t))
      (goto-char (match-beginning 0)))))

(defun qvsa-pkg-lsd-arrange-headings (string)
  (while
      (re-search-forward
       "\\(^.+\\):[^]]*\n\\|^ *\\(\\[[^][]+\\]\\)$\\|(\\([^)]+\\), PMID [0-9]+)$"
       nil t)
    (cond
     ((match-beginning 1)
      (qvs-make-region-heading (match-beginning 1) (match-end 1) 2))
     ((match-beginning 2)
      (qvs-make-region-heading (match-beginning 2) (match-end 2) 3))
     ((match-beginning 3)
      (qvs-make-region-heading (match-beginning 3) (match-end 3) 4))
     )))

(setq qvs-package-dictionary-options-alist
      (list (cons "lsd"
		  qvsa-pkg-lsd-dictionary-options)))

;; qvsa-pkg-lsd.el ends
